#ifndef PQUEUE_
#define PQUEUE_

#include <stddef.h>
#include <stdbool.h>

struct pqueue;

struct pqueue * pqueue_new(size_t max, bool (*comp)(void const * const a, void const * const b));
void pqueue_delete(struct pqueue * pq);

void *  pqueue_push (struct pqueue * pq, void * elem);
void *  pqueue_pop  (struct pqueue * pq);
void *  pqueue_peek (struct pqueue * pq);
size_t  pqueue_size (struct pqueue * pq);

#endif // ndef PQUEUE_
